/*---------------------------------------------------------------------------*
 |          Copyright (c) 2002-2018 PDFlib GmbH. All rights reserved.        |
 +---------------------------------------------------------------------------+
 |    This software may not be copied or distributed except as expressly     |
 |    authorized by PDFlib GmbH's general license agreement or a custom      |
 |    license agreement signed by PDFlib GmbH.                               |
 |    For more information about licensing please refer to www.pdflib.com.   |
 *---------------------------------------------------------------------------*/

/*
 * PLOPException Java class
 */

package com.pdflib;

/** PDFlib PLOP: PDF Linearization, Optimization, Protection      
    Exception handling for PLOP.
    @author Rainer Schaaf
    @version 5.3
*/

public class PLOPException extends Exception {
    public PLOPException() {
	super();
    }

    public PLOPException(String msg) {
	super(msg);
    }

    public PLOPException(String msg, int errnum, String apiname) {
	super(msg);
	plop_errnum = errnum;
	plop_apiname = apiname;
    }

    /** Map standard getMessage method to get_errmsg.
     * 
     * @return	A string describing the error, or an empty string if the
     * 		last API call didn't cause any error. 
     */
    public String get_errmsg() {
        return super.getMessage();
    }

    /** Get the error number of the exception.
     * @return	The exception's error number. 
     */
    public int get_errnum() {
	return plop_errnum;
    }

    /** Get the name of the API function which caused the exception.
     * @return	The name of an API function. 
     */
    public String get_apiname() {
	return plop_apiname;
    }

    private int plop_errnum;
    private String plop_apiname;
}
